function [ weights, resTraindata ] = perceptron( traindata, trainclass, rozsireni, prah)
% rozsireni false = bez rozsireni
% rozsireni true = s rozsirenim
% [ weights, resTraindata ] = perceptron( traindata,trainclass,false,0);

radky = size(traindata, 1); %vrati pocet radku
weights = rand(2,1).*100;   %inicializace dat dle vzorce; w pro 2 dimenze
resTraindata = traindata;   

if(rozsireni)   %pokud je pozadovano rozsireni baze
    weights = rand(5,1).*100;   %nutno zmenit w pro 5 dim
    resTraindata = expandData(traindata);    
end

maxIterations = 500000;
stejneWeights = 100;
pocetIteraci = 0;
nextIterace = true;
citacStejneWeights = 0;

while(nextIterace)
    weightsHelp = weights;
    pocetIteraci = pocetIteraci + 1;
    nahodnyVector = int32(1 + (radky - 1) * rand(1));
    yx = sign(sum(resTraindata(nahodnyVector,:) * weights - prah));
    dx = trainclass(nahodnyVector);

    if(yx ~= dx)
        weights = weights(:,1) + 0.5 * (dx - yx) * transpose(resTraindata(nahodnyVector,:));
    end
    
    if(weightsHelp == weights)
        citacStejneWeights = citacStejneWeights + 1;
    else
        citacStejneWeights = 0;
    end
    
    if(pocetIteraci >= maxIterations || citacStejneWeights >= stejneWeights)
        nextIterace = false;
    end
end

fprintf('Konecny pocet iteraci %d\n', pocetIteraci);
end

